//+------------------------------------------------------------------+
//| sto rsi ma cross sig                                             |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
//mod 2008 fxtsd   ki

#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"


#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_width1 1
#property indicator_width2 1


extern int FastMA       =    5;
extern int FastMAmode   =    1; // 
extern int FastMAprice=PRICE_CLOSE;

extern int SlowMA        =   10;
extern int SlowMAmode    =   1; //
extern int SlowMAprice=PRICE_CLOSE;

extern string   MA_Method_ = "SMA0 EMA1 SMMA2 LWMA3";
extern string   note_Price = "0C 1O 2H 3L 4Md 5Tp 6WghC: Md(HL/2)4,Tp(HLC/3)5,Wgh(HLCC/4)6";


extern int stoKperiod = 10;
extern int stoDperiod = 3;
extern int stoSlowing = 3;
extern int stoMAmethod= 1;
extern int stoPrice_field  = 1;
extern int stoLine_mode    = 0;

extern string note_method_ = "MAmethod: SMA0 EMA1 SMMA2 LWMA3"; 
extern string price_field_ = "0- Low/High  1- Close/Close" ;
extern string line_mode___ = "0- main 1- signal line" ;

extern int RSI_period      = 14;
extern int RSI_price       = 0;


extern int SignalOfset = 11;

//---- 

double UpBuffer[];
double DnBuffer[];


double Range, AvgRange;

//+------------------------------------------------------------------+

int init()
  {

//   IndicatorBuffers(5);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexStyle(1,DRAW_ARROW);
    
   SetIndexArrow(0,233);//159
   SetIndexArrow(1,234);//159

   SetIndexLabel(0,"Up Signal");
   SetIndexLabel(1,"Down Signal");

   SetIndexBuffer(0,UpBuffer);
   SetIndexBuffer(1,DnBuffer);
   
   SetIndexEmptyValue(0,EMPTY_VALUE);
   SetIndexEmptyValue(1,EMPTY_VALUE);
  

   return(0);
  }
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }

//+------------------------------------------------------------------+
int start()
{
  
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) counted_bars=0;
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
 
   for(int i=0; i<limit;i++)
   {       
 
      int counter=i;
      Range=0;
      AvgRange=0;

      for (counter=i ;counter<=i+9;counter++)
       {
      AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
       }
      Range=AvgRange/10;
 
   


      double fastMA0 = iMA(NULL, 0, FastMA, 0, FastMAmode, FastMAprice, i);
      double fastMA1 = iMA(NULL, 0, FastMA, 0, FastMAmode, FastMAprice, i+1);
            
      double slowMA0 = iMA(NULL, 0, SlowMA, 0, SlowMAmode, SlowMAprice, i);
      double slowMA1 = iMA(NULL, 0, SlowMA, 0, SlowMAmode, SlowMAprice, i+1);



         double rsi  =iRSI(NULL,0,RSI_period,RSI_price,i);
         double rsi1 =iRSI(NULL,0,RSI_period,RSI_price,i+1);
         
         
         double sto  =iStochastic(NULL,0,stoKperiod,stoDperiod,stoSlowing,stoMAmethod,stoPrice_field,stoLine_mode,i);
         double sto1 =iStochastic(NULL,0,stoKperiod,stoDperiod,stoSlowing,stoMAmethod,stoPrice_field,stoLine_mode,i+1);

      if( fastMA0>slowMA0 && fastMA1<slowMA1 && sto>sto1 && sto<80 && rsi>50) // fastMAxslowMA
  
         {  
         UpBuffer[i] = iLow(Symbol(),0,i)-(Range+SignalOfset*Point);
         DnBuffer[i] = EMPTY_VALUE;
         }
      
      else 
      
      if( fastMA0<slowMA0 && fastMA1>slowMA1 && sto<sto1 && sto>20 && rsi<50)
         {
         UpBuffer[i] = EMPTY_VALUE;
         DnBuffer[i] = iHigh(Symbol(),0,i)+(Range+SignalOfset*Point);
         }
     
      else
         {
         DnBuffer[i] = EMPTY_VALUE;
         UpBuffer[i] = EMPTY_VALUE;
         }
 
   }
   return(0);
}



